"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Key = exports.create = void 0;
const crypto = __importStar(require("crypto"));
function create(seed) {
    return new Promise((rs, rj) => {
        crypto.randomBytes(32, (err, key) => {
            if (err) {
                rj(err);
                return;
            }
            crypto.randomBytes(12, (err, nounce) => {
                if (err) {
                    rj(err);
                    return;
                }
                rs(new Key({
                    hashSeed: seed,
                    symetric: {
                        key: key.toString('base64'),
                        nounce: nounce.toString('base64'),
                    },
                }));
            });
        });
    });
}
exports.create = create;
class Key {
    constructor(prob) {
        this.hashSeed = prob.hashSeed;
        this.symetric = {
            key: Buffer.from(prob.symetric.key, 'base64'),
            nounce: Buffer.from(prob.symetric.nounce, 'base64'),
        };
    }
    decrypt(dec) {
        let decipher = crypto.createDecipheriv('chacha20-poly1305', this.symetric.key, this.symetric.nounce, {
            authTagLength: 4,
        });
        const ret = decipher.update(Buffer.from(dec, 'base64'));
        decipher.final();
        return ret;
    }
    encrypt(enc) {
        const cipher = crypto.createCipheriv('chacha20-poly1305', this.symetric.key, this.symetric.nounce, {
            authTagLength: 4,
        });
        let out;
        if (typeof enc === 'string') {
            out = Buffer.from(enc);
        }
        else {
            out = enc;
        }
        const ret = cipher.update(out);
        cipher.final();
        return ret.toString('base64');
    }
    hash(enc) {
        const hasher = crypto.createHash('sha256');
        hasher.update(this.hashSeed);
        hasher.update(enc.toUpperCase().replace(/[\n\r \t]+/g, ''));
        return hasher.digest('base64');
    }
}
exports.Key = Key;
//# sourceMappingURL=key.js.map